Index: /extensions/GrumPluginClasses/admin.php
===================================================================
--- /extensions/GrumPluginClasses/admin.php	(revision 16457)
+++ /extensions/GrumPluginClasses/admin.php	(revision 16458)
@@ -4,6 +4,5 @@
   Author     : Grum
     email    : grum@piwigo.org
-    website  : http://photos.grum.fr
-    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706
+    website  : http://www.grum.fr
 
     << May the Little SpaceFrog be with you ! >>
Index: /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php	(revision 16457)
+++ /extensions/GrumPluginClasses/classes/CommonPlugin.class.inc.php	(revision 16458)
@@ -9,6 +9,5 @@
   Author     : Grum
     email    : grum@piwigo.org
-    website  : http://photos.grum.fr
-    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706
+    website  : http://www.grum.fr
 
     << May the Little SpaceFrog be with you ! >>
Index: /extensions/GrumPluginClasses/classes/GPCCss.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCCss.class.inc.php	(revision 16457)
+++ /extensions/GrumPluginClasses/classes/GPCCss.class.inc.php	(revision 16458)
@@ -10,6 +10,5 @@
   Author     : Grum
     email    : grum@piwigo.org
-    website  : http://photos.grum.fr
-    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706
+    website  : http://www.grum.fr
 
     << May the Little SpaceFrog be with you ! >>
Index: /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 16457)
+++ /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 16458)
@@ -9,6 +9,5 @@
   Author     : Grum
     email    : grum@piwigo.org
-    website  : http://photos.grum.com
-    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706
+    website  : http://www.grum.fr
 
     << May the Little SpaceFrog be with you ! >>
Index: /extensions/GrumPluginClasses/classes/GPCUserAgent.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCUserAgent.class.inc.php	(revision 16457)
+++ /extensions/GrumPluginClasses/classes/GPCUserAgent.class.inc.php	(revision 16458)
@@ -5,4 +5,22 @@
 class GPCUserAgent
 {
+  /**
+   * parse a user agent string and return an array of normalized informations
+   *
+   * returned:
+   *  array(
+   *    'os'               => (integer)
+   *    'os_version'       => (string)
+   *    'browser'          => (integer)
+   *    'browser_name'     => (string)
+   *    'browser_type'     => (integer)
+   *    'browser_version'  => (string)
+   *    'engine'           => (integer)
+   *    'engine_version'   => (string)
+   *  )
+   *
+   * @param String $userAgent
+   * @return Array
+   */
   static public function parse($userAgent)
   {
@@ -10,39 +28,97 @@
 
     $returned=array(
-      'os' => '',
-      'os_version' => '',
-
-      'browser' => '',
-      'browser_name' => '',
-      'browser_type' => '',
-      'browser_version' => '',
-
-      'engine' => '',
-      'engine_version' => ''
+      UA_DATA_OS              => UA_OS_UNKNOWN,
+      UA_DATA_OS_VERSION      => '',
+
+      UA_DATA_BROWSER         => UA_BOT_UNKNOWN,
+      UA_DATA_BROWSER_NAME    => '',
+      UA_DATA_BROWSER_TYPE    => UA_PROP_TYPE_UNKNOWN,
+      UA_DATA_BROWSER_VERSION => '',
+
+      UA_DATA_ENGINE          => UA_ENGINE_UNKNOWN,
+      UA_DATA_ENGINE_VERSION  => ''
     );
 
     $bot=self::getBot($userAgent);
-    if($bot['crawler']!=='')
-    {
-      $returned['browser']=$bot['crawler'];
-      $returned['browser_name']=$bot['name'];
-      $returned['browser_type']=UA_PROP_TYPE_CRAWLER;
-      $returned['browser_version']=str_replace(array(';', '(', ')'), array('', '', ''), $bot['version']);
+    if($bot[UA_DATA_BROWSER]!=='')
+    {
+      $returned[UA_DATA_BROWSER]=$bot[UA_DATA_BROWSER];
+      $returned[UA_DATA_BROWSER_TYPE]=UA_BROWSER_TYPE_CRAWLER;
+      $returned[UA_DATA_BROWSER_VERSION]=str_replace(array(';', '(', ')'), array('', '', ''), $bot[UA_DATA_BROWSER_VERSION]);
       return($returned);
     }
 
     $tmp=self::getBrowser($userAgent);
-    $returned['browser']=$tmp['browser'];
-    $returned['browser_name']=$tmp['name'];
-    $returned['browser_type']=$UA_BrowserInfo[UA_DATA_BROWSER][$tmp['browser']][UA_PROP_TYPE];
-    $returned['browser_version']=str_replace(array(';', '(', ')'), array('', '', ''), $tmp['version']);
+    $returned[UA_DATA_BROWSER]=$tmp[UA_DATA_BROWSER];
+    $returned[UA_DATA_BROWSER_TYPE]=$UA_BrowserInfo[UA_DATA_BROWSER][$tmp[UA_DATA_BROWSER]][UA_PROP_TYPE];
+    $returned[UA_DATA_BROWSER_VERSION]=str_replace(array(';', '(', ')'), array('', '', ''), $tmp[UA_DATA_BROWSER_VERSION]);
 
     $tmp=self::getOs($userAgent);
-    $returned['os']=$tmp['os'];
-    $returned['os_version']=str_replace(array(';', '(', ')'), array('', '', ''), $tmp['version']);
+    $returned[UA_DATA_OS]=$tmp[UA_DATA_OS];
+    $returned[UA_DATA_OS_VERSION]=str_replace(array(';', '(', ')'), array('', '', ''), $tmp[UA_DATA_OS_VERSION]);
 
     $tmp=self::getEngine($userAgent);
-    $returned['engine']=$tmp['engine'];
-    $returned['engine_version']=str_replace(array(';', '(', ')'), array('', '', ''), $tmp['version']);
+    $returned[UA_DATA_ENGINE]=$tmp[UA_DATA_ENGINE];
+    $returned[UA_DATA_ENGINE_VERSION]=str_replace(array(';', '(', ')'), array('', '', ''), $tmp[UA_DATA_ENGINE_VERSION]);
+
+    // explicit OS for mobile device override the browser type
+    if($returned[UA_DATA_OS]==UA_OS_BLACKBERRY or
+        $returned[UA_DATA_OS]==UA_OS_SYMBIAN_OS or
+        $returned[UA_DATA_OS]==UA_OS_SYMBOS or
+        $returned[UA_DATA_OS]==UA_OS_ANDROID or
+        $returned[UA_DATA_OS]==UA_OS_IOS) $returned[UA_DATA_BROWSER_TYPE]=UA_BROWSER_TYPE_MOBILE;
+
+    // explicit OS for console device override the browser type
+    if($returned[UA_DATA_OS]==UA_OS_NINTENDO_DS or
+        $returned[UA_DATA_OS]==UA_OS_NINTENDO_WII or
+        $returned[UA_DATA_OS]==UA_OS_SONY_PS3 or
+        $returned[UA_DATA_OS]==UA_OS_SONY_PSP) $returned[UA_DATA_BROWSER_TYPE]=UA_BROWSER_TYPE_CONSOLE;
+
+    return($returned);
+  }
+
+
+  /**
+   * from a user agent array properties, return an array completed with associated
+   * properties
+   *
+   * @param Array $userAgent
+   * @return Array
+   */
+  static public function getProperties($userAgent)
+  {
+    global $UA_BrowserInfo;
+
+    $returned=array();
+    if(isset($userAgent[UA_DATA_BROWSER]) and isset($UA_BrowserInfo[UA_DATA_BROWSER][$userAgent[UA_DATA_BROWSER]]))
+    {
+      $returned[UA_DATA_BROWSER]=$userAgent[UA_DATA_BROWSER];
+      $returned[UA_DATA_BROWSER_NAME]=$UA_BrowserInfo[UA_DATA_BROWSER][$userAgent[UA_DATA_BROWSER]][UA_PROP_NAME];
+      $returned[UA_DATA_BROWSER_URL]=$UA_BrowserInfo[UA_DATA_BROWSER][$userAgent[UA_DATA_BROWSER]][UA_PROP_URL];
+    }
+
+    if(!isset($userAgent[UA_DATA_BROWSER_TYPE]) and isset($userAgent[UA_DATA_BROWSER]))
+      $userAgent[UA_DATA_BROWSER_TYPE]=$UA_BrowserInfo[UA_DATA_BROWSER][$userAgent[UA_DATA_BROWSER]][UA_PROP_TYPE];
+
+    if(isset($userAgent[UA_DATA_BROWSER_TYPE]) and isset($UA_BrowserInfo[UA_DATA_BROWSER_TYPE][$userAgent[UA_DATA_BROWSER_TYPE]]))
+    {
+      $returned[UA_DATA_BROWSER_TYPE]=$userAgent[UA_DATA_BROWSER_TYPE];
+      $returned[UA_DATA_BROWSER_TYPE_NAME]=$UA_BrowserInfo[UA_DATA_BROWSER_TYPE][$userAgent[UA_DATA_BROWSER_TYPE]];
+    }
+
+
+    if(isset($userAgent[UA_DATA_OS]) and isset($UA_BrowserInfo[UA_DATA_OS][$userAgent[UA_DATA_OS]]))
+    {
+      $returned[UA_DATA_OS]=$userAgent[UA_DATA_OS];
+      $returned[UA_DATA_OS_NAME]=$UA_BrowserInfo[UA_DATA_OS][$userAgent[UA_DATA_OS]][UA_PROP_NAME];
+      $returned[UA_DATA_OS_URL]=$UA_BrowserInfo[UA_DATA_OS][$userAgent[UA_DATA_OS]][UA_PROP_URL];
+    }
+
+    if(isset($userAgent[UA_DATA_ENGINE]) and isset($UA_BrowserInfo[UA_DATA_ENGINE][$userAgent[UA_DATA_ENGINE]]))
+    {
+      $returned[UA_DATA_ENGINE]=$userAgent[UA_DATA_ENGINE];
+      $returned[UA_DATA_ENGINE_NAME]=$UA_BrowserInfo[UA_DATA_ENGINE][$userAgent[UA_DATA_ENGINE]][UA_PROP_NAME];
+      $returned[UA_DATA_ENGINE_URL]=$UA_BrowserInfo[UA_DATA_ENGINE][$userAgent[UA_DATA_ENGINE]][UA_PROP_URL];
+    }
 
     return($returned);
@@ -89,6 +165,44 @@
       '(ichiro)\/(\S*)\('                               => UA_BOT_ICHIRO,
       '(ichiro)(?:\/(\S*))*'                            => UA_BOT_ICHIRO,
+      '(l.webis)(?:\/(\S*))*'                           => UA_BOT_LWEBIS,
+      '(larbin)'                                        => UA_BOT_LARBIN,
+      '(linkwalker)(?:\/(\S*))*'                        => UA_BOT_LINKWALKER,
+      '(lwp-trivial)(?:\/(\S*))*'                       => UA_BOT_LWPTRIVIAL,
+      '(mabontland)'                                    => UA_BOT_MABONLAND,
+      '(mnogosearch)'                                   => UA_BOT_MNOGOSEARCH,
+      '(mogimogi)(?:\/(\S*))*'                          => UA_BOT_MOGIMOGI,
+      '(morning\spaper)'                                => UA_BOT_MORNINGPAPER,
+      '(netresearchserver)\/(\S*)\('                    => UA_BOT_NETRESEARCHSERVER,
+      '(netresearchserver)(?:\/(\S*))*'                 => UA_BOT_NETRESEARCHSERVER,
+      '(newsgator)(?:\/(\S*))*'                         => UA_BOT_NEWSGATOR,
+      '(ng-search)(?:\/(\S*))*'                         => UA_BOT_NGSEARCH,
+      '(nymesis)(?:\/(\S*))*'                           => UA_BOT_NYMESIS,
+      '(oegp)'                                          => UA_BOT_OEGP,
+      '(pompos)(?:\/(\S*))*'                            => UA_BOT_POMPOS,
+      '(pycurl)(?:\/(\S*))*'                            => UA_BOT_PYCURL,
+      '(qseero)'                                        => UA_BOT_QSEERO,
+      '(sbider)(?:\/(\S*))*'                            => UA_BOT_SBIDER,
+      '(scoutjet)'                                      => UA_BOT_SCOUTJET,
+      '(scrubby)(?:\/(\S*))*'                           => UA_BOT_SCRUBBY,
+      '(searchsight)(?:\/(\S*))*'                       => UA_BOT_SEARCHSIGHT,
+      '(semanticdiscovery)(?:\/(\S*))*'                 => UA_BOT_SEMANTICDISCOVERY,
+
+      '(shoula)'                                        => UA_BOT_SHOULA,
+      '(snappy)(?:\/(\S*))*'                            => UA_BOT_SNAPPY,
+      '(stackrambler)(?:\/(\S*))*'                      => UA_BOT_STACKRAMBLER,
+      '(silk)(?:\/(\S*))*'                              => UA_BOT_SILK,
+      '(teoma)'                                         => UA_BOT_TEOMA,
+      '(tineye)(?:\/(\S*))*'                            => UA_BOT_TINEYE,
+      '(truwogps)(?:\/(\S*))*'                          => UA_BOT_TRUWOGPS,
+      '(updated)(?:\/(\S*))*'                           => UA_BOT_UPDATED,
+      '(voyager)(?:\/(\S*))*'                           => UA_BOT_VOYAGER,
+      '(vyu2)'                                          => UA_BOT_VYU2,
+      '(webcollage)(?:\/(\S*))*'                        => UA_BOT_WEBCOLLAGE,
+      '(yooglifetchagent)(?:\/(\S*))*'                  => UA_BOT_YOOGLIFETCHAGENT,
+      '(zao)(?:\/(\S*))*'                               => UA_BOT_ZAO,
+      '(zealbot)'                                       => UA_BOT_ZEALBOT,
       '(baiduspider)'                                   => UA_BOT_BAIDU,
       '(msnbot)\/(\d+(?:\.\d+)*)'                       => UA_BOT_MSN_SEARCH,
+      '(msnbot)\s(\d+(?:\.\d+)*)'                       => UA_BOT_MSN_SEARCH,
       '(exabot)\/(\d+(?:\.\d+)*)'                       => UA_BOT_EXALEAD,
       '(gamespyhttp)\/(\d+(?:\.\d+)*)'                  => UA_BOT_GAMESPY,
@@ -96,11 +210,12 @@
       '(inktomi)'                                       => UA_BOT_INKTOMI,
       '(Yahoo! Slurp)'                                  => UA_BOT_YAHOO_SEARCH,
+      '(yahooseeker)'                                   => UA_BOT_YAHOO_SEARCH,
       '\s*([a-z]*(?:bot|spyder|crawl|crawler|spider)[a-z]*)'  => UA_BOT_UNKNOWN
     );
 
     $returned=array(
-      'crawler' => '',
-      'name' => '',
-      'version' => ''
+      UA_DATA_BROWSER => '',
+      //'name' => '',
+      UA_DATA_BROWSER_VERSION => ''
     );
 
@@ -110,8 +225,12 @@
       if(preg_match('/'.$regExp.'/i',$userAgent,$result))
       {
+        // exclude some case
+        if($crawler==UA_BOT_UNKNOWN and preg_match('/(?:msiecrawler)/i', $userAgent))
+          return($returned);
+
         $returned=array(
-          'crawler' => $crawler,
-          'name' => $result[1],
-          'version' => isset($result[2])?$result[2]:''
+          UA_DATA_BROWSER => $crawler,
+          //'name' => $result[1], #retrieved from the code
+          UA_DATA_BROWSER_VERSION => isset($result[2])?$result[2]:''
         );
         return($returned);
@@ -180,4 +299,5 @@
       '(chrome)\/(\S*)'                                       => UA_BROWSER_CHROME,
       '(epiphany)\/(\S*)'                                     => UA_BROWSER_EPIPHANY,
+      '(epiphany)'                                            => UA_BROWSER_EPIPHANY,
       '(galeon)\/(\S*)'                                       => UA_BROWSER_GALEON,
       '(orca)\/(\S*)'                                         => UA_BROWSER_ORCA,
@@ -203,7 +323,7 @@
 
     $returned=array(
-      'browser' => UA_BROWSER_UNKNOWN,
-      'name' => '',
-      'version' => ''
+      UA_DATA_BROWSER => UA_BROWSER_UNKNOWN,
+      //'name' => '',
+      UA_DATA_BROWSER_VERSION => ''
     );
 
@@ -214,5 +334,5 @@
       {
         //echo print_r($userAgent, true).print_r($result, true);
-        if(is_array($result) and count($result)>2)
+        if(is_array($result) and count($result)>=2)
         {
           if($browser==UA_BROWSER_SAFARI and preg_match('/iphone|ipad|ipod/i', $userAgent))
@@ -220,7 +340,7 @@
 
           $returned=array(
-            'browser' => $browser,
-            'name' => $result[1],
-            'version' => isset($result[2])?$result[2]:''
+            UA_DATA_BROWSER => $browser,
+            //'name' => $result[1],
+            UA_DATA_BROWSER_VERSION => isset($result[2])?$result[2]:''
           );
         }
@@ -228,7 +348,7 @@
         {
           $returned=array(
-            'browser' => UA_BROWSER_UNKNOWN,
-            'name' => '',
-            'version' => ''
+            UA_DATA_BROWSER => UA_BROWSER_UNKNOWN,
+            //'name' => '',
+            UA_DATA_BROWSER_VERSION => ''
           );
         }
@@ -257,4 +377,5 @@
       '(sunos)'                                               => UA_OS_SUNOS,
       '(blackberry)\s?([^;.]*);'                              => UA_OS_BLACKBERRY,
+      '(blackberry)'                                          => UA_OS_BLACKBERRY,
       '(symbianos)'                                           => UA_OS_SYMBIAN_OS,
       '(symbos)'                                              => UA_OS_SYMBOS,
@@ -267,4 +388,7 @@
       '(windows)\s?(\S*)[\;\)]'                               => UA_OS_WINDOWS,
       '(windows)\s?(\S*)'                                     => UA_OS_WINDOWS,
+      '(winnt)'                                               => UA_OS_WINDOWS,
+      '(win98)'                                               => UA_OS_WINDOWS,
+      '(win95)'                                               => UA_OS_WINDOWS,
       '(mac_powerpc)'                                         => UA_OS_MACINTOSH,
       '(cpu\siphone\sos)\s?(\S*)'                             => UA_OS_IOS,
@@ -276,12 +400,23 @@
       '(playstation\s3)'                                      => UA_OS_SONY_PS3,
       '(playstation\sportable)'                               => UA_OS_SONY_PSP,
-      '(nintendo\sds)'                                        => UA_OS_NINTENDO_DS
-
+      '(nintendo\sds)'                                        => UA_OS_NINTENDO_DS,
+      '(cros)(?:\s*i\d*)(?:\s(\S*))'                          => UA_OS_CHROME_OS,
+      '(cros)'                                                => UA_OS_CHROME_OS,
+      '(beos)'                                                => UA_OS_BE_OS,
+      '(dragonfly)'                                           => UA_OS_DRAGONFLY,
+      '(unix)'                                                => UA_OS_UNIX,
+      '(darwin)'                                              => UA_OS_DARWIN,
+      '(macintosh)'                                           => UA_OS_MACINTOSH,
+      '(fedora)'                                              => UA_OS_LINUX,
+      '(os\/2).*(warp(?:\s\S*));'                             => UA_OS_OS2,
+      '(os\/2)'                                               => UA_OS_OS2,
+      '(amigaos)(?:\s(\S*))'                                  => UA_OS_AMIGAOS,
+      '(amigaos)'                                             => UA_OS_AMIGAOS
     );
 
     $returned=array(
-      'os' => UA_OS_UNKNOWN,
-      'name' => '',
-      'version' => ''
+      UA_DATA_OS => UA_OS_UNKNOWN,
+      //'name' => '',
+      UA_DATA_OS_VERSION => ''
     );
 
@@ -292,12 +427,12 @@
       {
         $returned=array(
-          'os' => $os,
-          'name' => $result[1],
-          'version' => isset($result[2])?$result[2]:''
+          UA_DATA_OS => $os,
+          //'name' => $result[1],
+          UA_DATA_OS_VERSION => isset($result[2])?$result[2]:''
         );
         switch($os)
         {
           case UA_OS_WINDOWS:
-            switch($returned['version'])
+            switch($returned[UA_DATA_OS_VERSION])
             {
               case 'NT 5.0':
@@ -338,16 +473,16 @@
   {
     $engineList=array(
-      '(presto)\/(\S*)'           => UA_ENGINE_PRESTO,
-      '(gecko)\/(\S*)'            => UA_ENGINE_GECKO,
-      '(applewebkit)\/(\S*)'      => UA_ENGINE_APPLEWEBKIT,
-      '(webkit)\/(\S*)'           => UA_ENGINE_WEBKIT,
-      '(khtml)\/(\S*)'            => UA_ENGINE_KHTML,
-      '(trident)\/(\S*)'          => UA_ENGINE_TRIDENT
+      '(presto)(?:\/(\S*))*'           => UA_ENGINE_PRESTO,
+      '(applewebkit)(?:\/(\S*))*'      => UA_ENGINE_APPLEWEBKIT,
+      '(webkit)(?:\/(\S*))*'           => UA_ENGINE_WEBKIT,
+      '(khtml)(?:\/(\S*))*'            => UA_ENGINE_KHTML,
+      '(gecko)(?:\/(\S*))*'            => UA_ENGINE_GECKO,
+      '(trident)(?:\/(\S*))*'          => UA_ENGINE_TRIDENT
     );
 
     $returned=array(
-      'engine' => UA_ENGINE_UNKNOWN,
-      'name' => '',
-      'version' => ''
+      UA_DATA_ENGINE => UA_ENGINE_UNKNOWN,
+      //'name' => '',
+      UA_DATA_ENGINE_VERSION => ''
     );
 
@@ -358,7 +493,7 @@
       {
         $returned=array(
-          'engine' => $engine,
-          'name' => $result[1],
-          'version' => isset($result[2])?$result[2]:''
+          UA_DATA_ENGINE => $engine,
+          //'name' => $result[1],
+          UA_DATA_ENGINE_VERSION => isset($result[2])?$result[2]:''
         );
         return($returned);
@@ -368,7 +503,5 @@
     return($returned);
   }
-
-
-}
+} // GPCUserAgent class
 
 
Index: /extensions/GrumPluginClasses/classes/GPCUserAgent.const.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCUserAgent.const.inc.php	(revision 16457)
+++ /extensions/GrumPluginClasses/classes/GPCUserAgent.const.inc.php	(revision 16458)
@@ -5,12 +5,28 @@
  * Data types : bot, browser, engine, os
  */
-define('UA_DATA',                     0x00);
-
-define('UA_DATA_BROWSER',             0x01);
-define('UA_DATA_ENGINE',              0x02);
-define('UA_DATA_OS',                  0x03);
-define('UA_DATA_BOT',                 0x04);
-
-define('UA_DATA_PROP_NAME',           0x10);
+define('UA_DATA',                     0x0000);
+
+define('UA_DATA_BROWSER',             0x0001);
+define('UA_DATA_ENGINE',              0x0002);
+define('UA_DATA_OS',                  0x0003);
+
+define('UA_DATA_BROWSER_NAME',        0x0011);
+define('UA_DATA_OS_NAME',             0x0012);
+define('UA_DATA_ENGINE_NAME',         0x0013);
+
+define('UA_DATA_BROWSER_VERSION',     0x0021);
+define('UA_DATA_ENGINE_VERSION',      0x0022);
+define('UA_DATA_OS_VERSION',          0x0023);
+
+define('UA_DATA_BROWSER_TYPE',        0x0031);
+define('UA_DATA_BROWSER_TYPE_NAME',   0x0131);
+define('UA_DATA_OS_TYPE',             0x0033);
+define('UA_DATA_OS_TYPE_NAME',        0x0133);
+
+define('UA_DATA_BROWSER_URL',         0x0041);
+define('UA_DATA_ENGINE_URL',          0x0042);
+define('UA_DATA_OS_URL',              0x0043);
+
+
 
 /**
@@ -23,12 +39,12 @@
 
 /**
- * -- UA_PROP_TYPE --
- * Indexes for UA_PROP_TYPE information (computer, mobile, console, ...)
- */
-define('UA_PROP_TYPE_UNKNOWN',          0x00);
-define('UA_PROP_TYPE_BROWSER_COMPUTER', 0x01);
-define('UA_PROP_TYPE_BROWSER_MOBILE',   0x02);
-define('UA_PROP_TYPE_BROWSER_CONSOLE',  0x03);
-define('UA_PROP_TYPE_CRAWLER',          0x04);
+ * -- UA_DATA_BROWSER_TYPE --
+ * Indexes for UA_DATA_BROWSER_TYPE information (computer, mobile, console, ...)
+ */
+define('UA_BROWSER_TYPE_UNKNOWN',   0x00);
+define('UA_BROWSER_TYPE_COMPUTER',  0x01);
+define('UA_BROWSER_TYPE_MOBILE',    0x02);
+define('UA_BROWSER_TYPE_CONSOLE',   0x03);
+define('UA_BROWSER_TYPE_CRAWLER',   0x04);
 
 /**
@@ -62,5 +78,41 @@
 define('UA_BOT_INKTOMI',              0x0018);
 define('UA_BOT_YAHOO_SEARCH',         0x0019);
-define('UA_BOT_ACCOONA_AI_AGENT',     0x0020);
+define('UA_BOT_ACCOONA_AI_AGENT',     0x001A);
+define('UA_BOT_LWEBIS',               0x001B);
+define('UA_BOT_LARBIN',               0x001C);
+define('UA_BOT_LINKWALKER',           0x001D);
+define('UA_BOT_LWPTRIVIAL',           0x001E);
+define('UA_BOT_MABONLAND',            0x001F);
+define('UA_BOT_MNOGOSEARCH',          0x0020);
+define('UA_BOT_MOGIMOGI',             0x0021);
+define('UA_BOT_MORNINGPAPER',         0x0022);
+define('UA_BOT_NETRESEARCHSERVER',    0x0023);
+define('UA_BOT_NEWSGATOR',            0x0024);
+define('UA_BOT_NGSEARCH',             0x0025);
+define('UA_BOT_NYMESIS',              0x0026);
+define('UA_BOT_OEGP',                 0x0027);
+define('UA_BOT_POMPOS',               0x0028);
+define('UA_BOT_PYCURL',               0x0029);
+define('UA_BOT_QSEERO',               0x002A);
+define('UA_BOT_SBIDER',               0x002B);
+define('UA_BOT_SCOUTJET',             0x002C);
+define('UA_BOT_SCRUBBY',              0x002D);
+define('UA_BOT_SEARCHSIGHT',          0x002E);
+define('UA_BOT_SEMANTICDISCOVERY',    0x002F);
+define('UA_BOT_SHOULA',               0x0030);
+define('UA_BOT_SNAPPY',               0x0031);
+define('UA_BOT_STACKRAMBLER',         0x0032);
+define('UA_BOT_SILK',                 0x0033);
+define('UA_BOT_TEOMA',                0x0034);
+define('UA_BOT_TINEYE',               0x0035);
+define('UA_BOT_TRUWOGPS',             0x0036);
+define('UA_BOT_UPDATED',              0x0037);
+define('UA_BOT_VOYAGER',              0x0038);
+define('UA_BOT_VYU2',                 0x0039);
+define('UA_BOT_WEBCOLLAGE',           0x003A);
+define('UA_BOT_YOOGLIFETCHAGENT',     0x003B);
+define('UA_BOT_ZAO',                  0x003C);
+define('UA_BOT_ZEALBOT',              0x003D);
+
 
 /**
@@ -142,4 +194,25 @@
 define('UA_OS_SONY_PS3',              0x10);
 define('UA_OS_SONY_PSP',              0x11);
+define('UA_OS_CHROME_OS',             0x12);
+define('UA_OS_BE_OS',                 0x13);
+define('UA_OS_DRAGONFLY',             0x14);
+define('UA_OS_UNIX',                  0x15);
+define('UA_OS_DARWIN',                0x16);
+define('UA_OS_OS2',                   0x17);
+define('UA_OS_AMIGAOS',               0x18);
+
+
+/**
+ * -- UA_OS_TYPE --
+ * Known OS type
+ */
+define('UA_OS_TYPE_UNKNOWN',          0x00);
+define('UA_OS_TYPE_LINUX',            0x01);
+define('UA_OS_TYPE_BSD',              0x02);
+define('UA_OS_TYPE_UNIX',             0x03);
+define('UA_OS_TYPE_WINDOWS',          0x04);
+define('UA_OS_TYPE_OS2',              0x05);
+
+
 
 /**
@@ -157,5 +230,4 @@
 $UA_BrowserInfo=array(
   UA_DATA => array(
-            UA_DATA_BOT     => array(UA_PROP_NAME => 'Robot'),
             UA_DATA_BROWSER => array(UA_PROP_NAME => 'Browser'),
             UA_DATA_ENGINE  => array(UA_PROP_NAME => 'Engine'),
